#!/tvbin/tivosh

# Select local channels script for DirecTivo's running software version 2.5.2
#
# USE AT YOUR OWN RISK
#
# Written by Juppers
# 
# Special thanks to an unnamed individual that solved the stopping
# after 50 channels problem.
#
# Will only bring up hidden channels that are between 0 and 100.

  
source /tvlib/tcl/tv/mfslib.tcl
set db [dbopen]
    RetryTransaction {
        set obj [db $db open /Setup]
        set s [dbobj $obj get Source]
        set channels [dbobj $s gettarget "Channel"]
    }

    foreach channel $channels {
        set apg ""
        regexp {([0-9]*)/(.*)} $channel junk fsid subobjid
        RetryTransaction {
            set obj [db $db openidconstruction $fsid $subobjid]
            set num [dbobj $obj get "Number"]
            if { $num < 100 } {
                try {
                set apg [dbobj $obj get ApgChannel]
                } catch errCode {
                puts "failed with: $errCode"
                }
        }             
            if { $apg != "" } {
                try {
                    set sn [dbobj $apg get "ShortName"]
                    puts "Checking $sn : $fsid/$subobjid"
                    foreach arg $argv {
                        if { [string match $arg* $sn] } {
                            try {
                            puts "$sn Has Been Added"
                            dbobj $apg remove CanBeViewed
                            dbobj $apg remove GuideInclusionExpr
                            dbobj $apg remove ConditionalDescriptorExpr
                            dbobj $apg remove AdditionalNetworkId
                            } catch errCode {
                            puts "failed with: $errCode"
                            }
                        }
                    }
                } catch errCode {
                puts "failed with: $errCode"
                }
            } 
        }
    }
dbclose $db
